// gcc -Wall -Wpedantic -Wextra -std=c2x -march=haswell popcount.c

#include <stdio.h>
#include <stdint.h>

uint8_t popcount1(uint64_t n) {
    uint8_t count = 0;
    while (n > 0) {
        if (n % 2 == 1) {    // 1 in the 1s place
            count += 1;
        }
        n >>= 1;             // shift right 1
    }
    return count;
}

uint8_t popcount2(uint64_t n) {
    uint8_t count = 0;
    while (n > 0) {
        count += 1;
        n &= n - 1;          // clear the lowest set bit
    }
    return count;
}

uint8_t popcount3(uint64_t n) {
    return (uint8_t)__builtin_popcountll(n);
}

int main() {
    uint64_t n = 0b01010100;
    printf("%hhu\n", popcount1(n));
    printf("%hhu\n", popcount2(n));
    printf("%hhu\n", popcount3(n));
    return 0;
}